//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  variables.hpp
//! \brief Declares class SVariRegistry.

#include "../trivia/singleton.hpp"

//! Registry for genusiable objects.

class SVariRegistry: public triv::ISingleton<SVariRegistry> {
 private:
    map<string,PObj> Map;       //! unsorted hash, for expression evaluation

public:
    PObj find( string key ) const;
    PObj find_or_fail( string key ) const;

    void display_functions() const;

    void register_scalar( string key, PObj val );
    bool undef( string key );
};
